from os import listdir, sep
from random import choice
from shutil import move
from traceback import format_exc
from pyrogram.client import Client
from pyrogram.types import InlineKeyboardMarkup, InlineKeyboardButton
from modules.logging import logWrite
from modules.utils import jsonLoad, jsonSave, configGet, locale

def send_content(app: Client):

    # Send post to channel
    try:

        index = jsonLoad(configGet("index", "locations"))
        list_queue = listdir(configGet("queue", "locations"))

        for file in list_queue:

            if not file in index["sent"]:

                ext_match = False

                for ext in configGet("photo", "posting", "extensions"):
                    if file.endswith(ext):
                        ext_match = True
                        ext_type = "photo"
                        break

                for ext in configGet("video", "posting", "extensions"):
                    if file.endswith(ext):
                        ext_match = True
                        ext_type = "video"
                        break

                if not ext_match:
                    list_queue.remove(file)

            else:
                list_queue.remove(file)

        if len(list_queue) > 0:
            candidate_file = choice(list_queue)
            candidate = configGet("queue", "locations")+sep+candidate_file
        else:
            logWrite(locale("post_empty", "console", locale=configGet("locale")))
            if configGet("error", "reports"):
                app.send_message(configGet("admin"), locale("post_empty", "message", locale=configGet("locale")))
            return

        if candidate_file in index["captions"]:
            caption = index["captions"][candidate_file]
        else:
            caption = ""

        if configGet("enabled", "caption"):
            if configGet("link", "caption") != None:
                caption = f"{caption}\n\n[{configGet('text', 'caption')}]({configGet('link', 'caption')})"
            else:
                caption = f"{caption}\n\n{configGet('text', 'caption')}"
        else:
            caption = caption

        if ext_type == "photo":

            if configGet("enabled", "caption"):
                if configGet("link", "caption") != None:
                    sent = app.send_photo(configGet("channel", "posting"), candidate, caption=caption, disable_notification=configGet("silent", "posting"))
                else:
                    sent = app.send_photo(configGet("channel", "posting"), candidate, caption=caption, disable_notification=configGet("silent", "posting"))
            else:
                sent = app.send_photo(configGet("channel", "posting"), candidate, caption=caption, disable_notification=configGet("silent", "posting"))

        elif ext_type == "video":

            if configGet("enabled", "caption"):
                if configGet("link", "caption") != None:
                    sent = app.send_video(configGet("channel", "posting"), candidate, caption=caption, disable_notification=configGet("silent", "posting"))
                else:
                    sent = app.send_video(configGet("channel", "posting"), candidate, caption=caption, disable_notification=configGet("silent", "posting"))
            else:
                sent = app.send_video(configGet("channel", "posting"), candidate, caption=caption, disable_notification=configGet("silent", "posting"))

        else:
            return

        index["sent"].append(candidate_file)
        index["last_id"] = sent.id

        jsonSave(index, configGet("index", "locations"))

        if configGet("move_sent", "posting"):
            move(candidate, configGet("sent", "locations")+sep+candidate_file)

        logWrite(locale("post_sent", "console", locale=configGet("locale")).format(candidate, ext_type, str(configGet("channel", "posting")), caption.replace("\n", "%n"), str(configGet("silent", "posting"))))

        if configGet("sent", "reports"):
            app.send_message(configGet("admin"), f"Posted `{candidate_file}`", disable_web_page_preview=True, reply_markup=InlineKeyboardMarkup([
                [InlineKeyboardButton(locale("post_view", "button", locale=configGet("locale")), url=sent.link)]
            ]))

    except Exception as exp:
        logWrite(locale("post_exception", "console", locale=configGet("locale")).format(str(exp), format_exc()))
        if configGet("error", "reports"):
            app.send_message(configGet("admin"), locale("post_exception", "message", locale=configGet("locale")).format(exp, format_exc()))
        pass


    # Work in progress
    # Check last posts forwards
    # check_forwards(app)